//program that reads in some names with birthdates and parses them

//secondly, user inputs 2 years and a weekday 
//program outputs all birthdates between those 2 years that are on user inputted weekday

// NB! CHANGE THE COOD  USING RECORDS
#include <stdio.h>
#include <string.h>

void fileNameFunction(char*, int);
int openFileFunction(char*, FILE*);
int recordsCounter(FILE*,char[][20],char[][20],int[],int[],int[]);
void DateF(char[][20],char[][20],int[],int[],int[], int);

int main(void)
{
/////declarations	///////////////////////////////////////////////////////////////////////////////////
	FILE * inputFile;
	char inputName[20];
	char nameArray[6][20];
	char surnameArray[6][20];
	int dayArray[10];
	int monthArray[10];
	int yearArray[10];
/////error case	///////////////////////////////////////////////////////////////////////////////////////
	int error = openFileFunction(inputName, inputFile);
	if (error == 1)
	{
		printf("\nFile exists.\n\n");	
	}
	
	else if (error == 0)
	{
		printf("File does not exist.");	
	}
/////main program	///////////////////////////////////////////////////////////////////////////////////
	inputFile = fopen(inputName, "r");
	int records = recordsCounter(inputFile, nameArray, surnameArray, dayArray, monthArray, yearArray); 
	printf("\nNumber of records is %d\n", records);
	DateF(nameArray, surnameArray, dayArray, monthArray, yearArray, records);
///////////////////////////////////////////////////////////////////////////////////////////////////////
	return(0);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
void fileNameFunction(char * inputName, int attempt)
{
	printf("What is the file name, %d attempts?\n", attempt);
	scanf("%s", inputName);
	
}
///////////////////////////////////////////////////////////////////////////////////////////////////////
int openFileFunction(char *inputName, FILE* inputFile)
{
	int attempt = 3;
	do{
		
		fileNameFunction(inputName, attempt);
		inputFile = fopen(inputName, "r");	
		if (inputFile != NULL)
			{
			return 1;
			}
		attempt--;
	}while(attempt != 0);
	return 0;
}
/////this function does a lot of things	//////////////////////////////////////////////////////////////
int recordsCounter(FILE * inputFile, char nameA[][20], char surnameA[][20],
int dayA[], int monthA[],int yearA[])
{
	int i = 0;
	int j = 0;
	char buffer[512];
	char name[21];
	char surname[21];
	int day, month, year;
	
	while(!feof(inputFile))
	{
		fgets(buffer, 512, inputFile);
		sscanf(buffer, "%s %s %d,%d,%d", name, surname, &day, &month, &year);  
		const int kuupikkused[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
/////parsing	/////////////////////////////////////////////////////////////////////////////////////
		if (year >= 1900 && month >= 1 && month <= 12 && day >= 1)
		{
			if (month == 2)
			{
				if (day <= 28)
				{
					printf("'%s' '%s' '%d' '%d' '%d'\n", name, surname, day, month, year);
/////saving to array for future use	/////////////////////////////////////////////////////////////////
					strcpy(nameA[j], name);
					strcpy(surnameA[j], surname);
					dayA[j] = day;
					monthA[j] = month;
					yearA[j] = year;
					j++;
				}	
				if (day == 29 && (year % 400 == 0 || (year % 4 == 0 && year % 100 != 0)))
				{
					printf("'%s' '%s' '%d' '%d' '%d'\n", name, surname, day, month, year);
					strcpy(nameA[j], name);
					strcpy(surnameA[j], surname);
					dayA[j] = day;
					monthA[j] = month;
					yearA[j] = year;
					j++;
				}
				else
				{
					printf("Date for %s's birthday does not exist\n", name);
				}
			}
			else
			{
				if (day <= kuupikkused[month - 1])
				{
					printf("'%s' '%s' '%d' '%d' '%d'\n", name, surname, day, month, year);
					strcpy(nameA[j], name);
					strcpy(surnameA[j], surname);
					dayA[j] = day;
					monthA[j] = month;
					yearA[j] = year;
					j++;
				}
				else
				{
					printf("Date for %s's birthday does not exist\n", name);
				}
			}
		}
		else
		{
			printf("Date for %s's birthday does not exist\n", name);
		}

		i++;
	}
	return i;
}

void DateF(char nameA[][20], char surnameA[][20], int dayA[], int monthA[], int yearA[], int records)
{
	int startYear, endYear, weekDay, i, k, j, temp;
	int m[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
	char* d[] = {"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday","Sunday"};
/////////////////////////////////////////////////////////////////////////////////////////////////////
	do
	{
		printf("\nEnter the year you like to start with: \n");
		scanf("%d", &startYear);   													
	}while(startYear < 1900 || startYear > 2100);
/////////////////////////////////////////////////////////////////////////////////////////////////////
	do
	{
		printf("\nEnter the year you like to end with: \n");
		scanf("%d", &endYear);   													
	}while(endYear < 1900 || endYear > 2100 ||endYear<startYear);
/////////////////////////////////////////////////////////////////////////////////////////////////////
	do
	{
		printf("\nEnter weekday that you want to find out about:\n(1 = monday, 2 = tuesday, 3 wednesday, 4 = thursday, 5 = friday, 6 = saturday, 7 = sunday)\n");
		scanf("%d", &weekDay); 
		if (weekDay == 7)
			weekDay = 0;
	}while(weekDay < 0 || weekDay > 7);
	printf("%s\n",d[weekDay]);
/////for each birthdate, finding the weekday it is during that year	/////////////////////////////////
	for(k = startYear; k < endYear+1; k++)
	{
		for(j = 0; j < 5; j++)
		{
			temp = dayA[j];
			for (i = 1900; i < k; i++)
			{
				
				if ((i ==1900)||(i % 4 != 0 && (i % 400 != 0 || i % 100 == 0)))
				{
					temp = temp + 365;
				}
				else
				{
					temp = temp + 366;
				}	
			}	
			
			for (i = 0; i < monthA[j] - 1; i++)
				{
				temp += m[i];
				}
				
				
/////comparing found weekday and user inputted weekday, if match, prints out	/////////////////////
			if (k%4 == 0 && monthA[j]> 2)
				if(temp % 7 == weekDay)
					printf(" %d, %d, %d, %s, %s\n", dayA[j], monthA[j], k, nameA[j], surnameA[j]);
			if (k%4 == 0 && monthA[j]< 2)
				if(temp % 7 == weekDay)
					printf(" %d, %d, %d, %s, %s\n", dayA[j], monthA[j], k, nameA[j], surnameA[j]);
			if (k%4 != 0)
				if(temp % 7 == weekDay)
					printf(" %d, %d, %d, %s, %s\n", dayA[j], monthA[j], k, nameA[j], surnameA[j]);	
		}
	}
}
